#ifndef DS3231_H
#define	DS3231_H

#include "Arduino.h"
#include <Wire.h>

class DS3231 {

public :
 
  DS3231();                                     // Constructor

  byte  GET_SECOND ();                   // Function to get the second from the DS2321 chip
  byte  GET_MINUTE();                    // Function to get the minute from the DS2321 chip
  byte  GET_HOUR (bool& h12, bool& PM);  // Function to get the hour from the DS2321 chip
  byte  GET_WEEKDAY();                   // Function to get the day of the week from the DS2321 chip
  byte  GET_DAY ();                      // Function to get the day of the month from the DS2321 chip
  byte  GET_MONTH (bool& Century);       // Function to get the month from the DS2321 chip
  byte  GET_YEAR ();                     // Function to get the year from DS2321 chip
  float GET_TEMPERATURE();               // Function to get the temperature from the DS2321 chip
  void  SET_SECOND (byte Second);        // Function to set the second on the DS3231 chip
  void  SET_MINUTE (byte Minute);        // Function to set the minute on the DS3231 chip
  void  SET_HOUR (byte Hour_Set);        // Function to set the hour on the DS3231 chip
  void  SET_WEEKDAY (byte DoW);          // Function to set the day of the week on the DS3231 chip
  void  SET_DAY (byte Date);             // Function to set the day of the month on the DS3231 chip
  void  SET_MONTH (byte Month);          // Function to set the month on the DS3231 chip
  void  SET_YEAR (byte Year);            // Function to set the year on the DS3231 chip

private :
  byte bcdToDec(byte val);               // Convert binary coded decimal to normal decimal numbers
  byte decToBcd(byte val);               // Convert decimal numbers to binary coded numbers

  // These two functions are used by the set second function to reset the Oscillator Stop Flag,
  // which is set whenever power is interrupted.
  byte readControlByte(bool which);
  void writeControlByte(byte control, bool which); 

};

#endif
